/*                                     ___   ___               */
/*           ▄▄▄       ██▓     ██▓███  |\  \ |\  \             */
/*          ▒████▄    ▓██▒    ▓██░  ██▒\ \  \\_\  \            */
/*          ▒██  ▀█▄  ▒██░    ▓██░ ██▓▒ \ \______  \           */
/*          ░██▄▄▄▄██ ▒██░    ▒██▄█▓▒ ▒  \|_____|\  \          */
/*           ▓█   ▓██▒░██████▒▒██▒ ░  ░         \ \__\         */
/*           ▒▒   ▓▒█░░ ▒░▓  ░▒▓▒░ ░  ░          \|__|         */
/*            ▒   ▒▒ ░░ ░ ▒  ░░▒ ░                             */
/*         F a░a s▒e && ░S░c h░ä f e r  \                      */
/*                ░  ░    ░  ░            S o  2 0 1 9         */



#ifndef FSALP42019_WORLD
#define FSALP42019_WORLD



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ INCLUDE ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
#include <stdio.h>                   // printf, sprintf
#include <stdlib.h>                  // exit
#include <pthread.h>                 // pthread_create/join
#include <time.h>                    // nanosleep
#include <ncurses.h>                 // screen drawing
#include "locks.h"
#include "globals.h"
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ INCLUDE ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/

/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ DECLARATION ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
void    run_world      (worldParameter * param);
void *  show_world     (void *);
void *  drive_car      (void * num_id);
int64_t bridge_status  (void);
void    print_thread_id(pthread_t thread_id, uint64_t number);
void    print_bridge   (void);
void    drive          (size_t index,
    struct timespec * sleep_timer,
    struct timespec * sleep_remainder);
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ DECLARATION ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/

extern uint64_t FSALP42019_WORLD_BRIDGE[];

typedef enum {LEFT, RIGHT} side;

pthread_mutex_t m_lock = PTHREAD_MUTEX_INITIALIZER;

#endif
